% Gradientna metoda pre vseobecnu funkciu

% ucelova funkcia
f = @(x) ...
    
% gradient
gr = @(x) ...
       
% startovaci bod
x0 = ...

% tolerancna konstanta 
eps = 1e-6;

% maximalny pocet iteracii
n = 100;       

%dlzka konstantneho kroku
c = ...

%Gradientna metoda s konstantnym krokom
[x, fh] = grad_const(...);

% vypisovanie iteracnych bodov
k = round(0:size(x,2)-1,1);
fprintf('====================================================== \n');
fprintf(' Gradientn metda s kontantnm krokom \n');
fprintf('------------------------------------------------------ \n');
fprintf('     k  |     x(1)      |     x(2)     | fh(k) \n');
fprintf('------------------------------------------------------ \n');
fprintf('  %4.0f  |  %4.10f | %4.10f | %4.10f \n' ,[k;x;fh]);
fprintf('------------------------------------------------------ \n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% parametre pre backtracking
alpha = .1; % alpha in (0, 1/2)
delta = .5; % delta in (0, 1)

%Gradientna metoda s priblizne optimalnym krokom
[x2, fh2] = grad_back(...);

% vypisovanie iteracnych bodov
k = round(0:size(x2,2)-1,1);
fprintf('====================================================== \n');
fprintf(' Gradientn metda s pribline optimlnym krokom \n');
fprintf('------------------------------------------------------ \n');
fprintf('     k  |     x(1)      |     x(2)     | fh(k) \n');
fprintf('------------------------------------------------------ \n');
fprintf('  %4.0f  |  %4.10f | %4.10f | %4.10f \n' ,[k;x2;fh2]);
fprintf('------------------------------------------------------ \n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Gradientna metoda s optimalnym krokom - Cauchyho metoda
[x3, fh3] = cauchy(...);


% vypisovanie iteracnych bodov
k = round(0:size(x2,2)-1,1);
fprintf('====================================================== \n');
fprintf(' Gradientn metda s kontantnm krokom \n');
fprintf('------------------------------------------------------ \n');
fprintf('     k  |     x(1)      |     x(2)     | fh(k) \n');
fprintf('------------------------------------------------------ \n');
fprintf('  %4.0f  |  %4.10f | %4.10f | %4.10f \n' ,[k;x3;fh3]);
fprintf('------------------------------------------------------ \n');
